//
//  AppDelegate.m
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 4/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate

//@synthesize persistentStoreCoordinator = _persistentStoreCoordinator;
//@synthesize managedObjectModel = _managedObjectModel;
//@synthesize managedObjectContext = _managedObjectContext;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    FLOG(@" called");
    // Insert code here to initialize your application
    [self initOSCDStackManager];
    
    //Register for StoreReady notification
    //[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(storeReady) name:OSStoreReadyNotification object:[OSxCDStackManager sharedManager]];

    //[[OSxCDStackManager sharedManager] checkUserICloudPreferenceAndSetupIfNecessary];
    [self setContentViewToMain];
    
}
- (void)initOSCDStackManager {
    [[OSxCDStackManager sharedManager] setUbiquityContainerKey:UBIQUITY_CONTAINER_KEY];
    [[OSxCDStackManager sharedManager] setUbiquityIDToken:UBID_TOKEN];
    [[OSxCDStackManager sharedManager] setCloudPreferenceKey:COMPANY_ID "." APP_NAME "." CLOUD_PREFERENCE_KEY];
    [[OSxCDStackManager sharedManager] setCloudPreferenceSet:COMPANY_ID "." APP_NAME "." CLOUD_PREFERENCE_SET];
    [[OSxCDStackManager sharedManager] setMakeBackupPreferenceKey:COMPANY_ID "." APP_NAME "." BACKUP_PREFERENCE_KEY];
    [[OSxCDStackManager sharedManager] setLoadInBackgroundPreferenceKey:COMPANY_ID "." APP_NAME "." BACKGROUNDLOAD_PREFERENCE_KEY];
    
}
- (void)storeReady {
    FLOG(@" called");
    [self performSelectorOnMainThread:@selector(setContentViewToMain) withObject:nil waitUntilDone:NO];
}
- (void)setContentViewToMainX  {
    FLOG(@" called");
}
- (void)setContentViewToMain  {
    FLOG(@" called");
     _mainWindowController = nil;
    if (_mainWindowController == nil) {
        
        _mainWindowController = [[MainWindowController alloc] initWithWindowNibName:@"MainWindowController"];
        
    }
    [_mainWindowController.window  makeKeyAndOrderFront:self];
}
// Returns the managed object context for the application (which is already bound to the persistent store coordinator for the application.)
- (NSManagedObjectContext *)managedObjectContext
{
    
    return [[OSxCDStackManager sharedManager] managedObjectContext];
}

// Returns the NSUndoManager for the application. In this case, the manager returned is that of the managed object context for the application.
- (NSUndoManager *)windowWillReturnUndoManager:(NSWindow *)window
{
    return [[[OSxCDStackManager sharedManager] managedObjectContext] undoManager];
}



- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
    // Save changes in the application's managed object context before the application terminates.
    FLOG(@" called");
    if (![[OSxCDStackManager sharedManager] managedObjectContext]) {
        [_mainWindowController close];
        return NSTerminateNow;
    }
    
    if (![[[OSxCDStackManager sharedManager] managedObjectContext] commitEditing]) {
        NSLog(@"%@:%@ unable to commit editing to terminate", [self class], NSStringFromSelector(_cmd));
        return NSTerminateCancel;
    }
    
    if (![[[OSxCDStackManager sharedManager] managedObjectContext] hasChanges]) {
        [_mainWindowController close];
        return NSTerminateNow;
    }
    
    NSError *error = nil;
    if (![[[OSxCDStackManager sharedManager] managedObjectContext] save:&error]) {
        
        // Customize this code block to include application-specific recovery steps.
        BOOL result = [sender presentError:error];
        if (result) {
            return NSTerminateCancel;
        }
        
        NSString *question = NSLocalizedString(@"Could not save changes while quitting. Quit anyway?", @"Quit without saves error question message");
        NSString *info = NSLocalizedString(@"Quitting now will lose any changes you have made since the last successful save", @"Quit without saves error question info");
        NSString *quitButton = NSLocalizedString(@"Quit anyway", @"Quit anyway button title");
        NSString *cancelButton = NSLocalizedString(@"Cancel", @"Cancel button title");
        NSAlert *alert = [[NSAlert alloc] init];
        [alert setMessageText:question];
        [alert setInformativeText:info];
        [alert addButtonWithTitle:quitButton];
        [alert addButtonWithTitle:cancelButton];
        
        NSInteger answer = [alert runModal];
        
        if (answer == NSAlertAlternateReturn) {
            return NSTerminateCancel;
        }
    }
    
    [_mainWindowController close];
    return NSTerminateNow;
}
- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication {
    FLOG(@" called");
    return YES;
}
- (BOOL)application:(NSApplication *)theApplication openFile:(NSString *)filename {
    FLOG(@" called with %@", filename);
    NSURL *url = [[NSURL alloc] initFileURLWithPath:filename];
    
    FLOG(@" url is %@", url);
    
    // Must initialise this because this method is called before didFinishLaunching
    [self initOSCDStackManager];
    [[OSxCDStackManager sharedManager] saveFile:url];
    return NO;
}
@end

