//
//  MainViewController.m
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 6/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import "CompanyViewController.h"
#import "OSxCDStackManager.h"

@interface CompanyViewController ()

@end

@implementation CompanyViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Initialization code here.
    }
    return self;
}
- (void)awakeFromNib {
    //FLOG(@"awakeFromNib called");

   // FLOG(@"  companyController is %@", companyController);
    
    companyController.managedObjectContext = _managedObjectContext;
    personController.managedObjectContext = _managedObjectContext;
    allPeopleController.managedObjectContext = _managedObjectContext;
    projectTypeController.managedObjectContext = _managedObjectContext;
    
    NSSortDescriptor * sd = [[NSSortDescriptor alloc] initWithKey:@"name" ascending:YES selector:@selector(caseInsensitiveCompare:)];
    
    [companyController setSortDescriptors:[NSArray arrayWithObject:sd]];
    [personController setSortDescriptors:[NSArray arrayWithObject:sd]];
    [allPeopleController setSortDescriptors:[NSArray arrayWithObject:sd]];
    [projectTypeController setSortDescriptors:[NSArray arrayWithObject:sd]];


    NSError *error = nil;
    BOOL ok = [companyController fetchWithRequest:nil merge:NO error:&error];
    if (!ok)
        FLOG(@" error getting company list");
    
    ok = [projectTypeController fetchWithRequest:nil merge:NO error:&error];
    if (!ok)
        FLOG(@" error getting project type list");
    
    [companyTableView reloadData];
    [peopleTableView reloadData];
    [allPeopleTableView reloadData];
    [projectTypeTableView reloadData];
    
    //FLOG(@" ProjectTypes:");
    FLOG(@" =============");
    //for (NSManagedObject *object in [projectTypeController arrangedObjects]) {
        //FLOG(@" %@", [object valueForKey:@"name"]);
    //}
    
}
-(void)setManagedObjectContext:(NSManagedObjectContext *)aManagedObjectContext {
    
    FLOG(@" called with %@", aManagedObjectContext);
    _managedObjectContext = aManagedObjectContext;
    

}

@end
