//
//  Person.h
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 6/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>
#import "OSManagedObject.h"

@class Company, Contact;

@interface Person : OSManagedObject {
    NSImage *_image;
}

@property (nonatomic, retain) NSString * email;
@property (nonatomic, retain) NSString * name;
@property (nonatomic, retain) NSString * phone;
@property (nonatomic, retain) NSData * imageData;

@property (nonatomic, retain) Company *employer;
@property (nonatomic, retain) NSSet *contacts;

// Transient
@property (nonatomic, retain) NSImage *image;

@end

@interface Person (CoreDataGeneratedAccessors)

- (void)addContactsObject:(Contact *)value;
- (void)removeContactsObject:(Contact *)value;
- (void)addContacts:(NSSet *)values;
- (void)removeContacts:(NSSet *)values;

@end

@interface Person (PrimitiveAccessors)
- (NSData *)primitiveImageData;
- (void)setPrimitiveImageData:(NSData *)newImageData;
@end