//
//  Person.m
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 6/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import "Person.h"
#import "Company.h"
#import "Contact.h"


@implementation Person

@dynamic email;
@dynamic name;
@dynamic phone;
@dynamic imageData;
@dynamic employer;
@dynamic contacts;

- (void)awakeFromInsert {
    [super awakeFromInsert];
    self.name = @"New Person (Mac)";
}

- (NSImage *)image {
    if (_image) {
        return _image;
    }
    
    _image = [[NSImage alloc] initWithData:self.imageData];
    
    return _image;
}
- (void)setImage:(NSImage *)anImage {
    if (anImage) {
        CGImageRef cgRef = [anImage CGImageForProposedRect:NULL
                                                 context:nil
                                                   hints:nil];
        NSBitmapImageRep *newRep = [[NSBitmapImageRep alloc] initWithCGImage:cgRef];
        [newRep setSize:[anImage size]];   // if you want the same resolution
        self.imageData = [newRep representationUsingType:NSPNGFileType properties:nil];
    }
}
- (void)setImageData:(NSData *)newImageData {
    _image = nil;
    [self willChangeValueForKey:@"imageData"];
    [self setPrimitiveImageData:newImageData];
    [self didChangeValueForKey:@"imageData"];
    
}
@end
