//
//  Project.h
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 6/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreData/CoreData.h>
#import "OSManagedObject.h"

@class Deliverable, Program, ProjectType;

@interface Project : OSManagedObject

@property (nonatomic, retain) NSString * name;
@property (nonatomic, retain) NSSet *deliverables;
@property (nonatomic, retain) Program *program;
@property (nonatomic, retain) ProjectType *projectType;
@end

@interface Project (CoreDataGeneratedAccessors)

- (void)addDeliverablesObject:(Deliverable *)value;
- (void)removeDeliverablesObject:(Deliverable *)value;
- (void)addDeliverables:(NSSet *)values;
- (void)removeDeliverables:(NSSet *)values;

@end
