//
//  MainWindowController.h
//  CoreDataLibraryAppOSX
//
//  Created by Duncan Groenewald on 12/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Macros.h"
#import "OSSidebarTableCellView.h"
#import "OSSideBarMenuItem.h"
#import "OSxCDStackManager.h"
#import "CompanyViewController.h"
#import "PeopleViewController.h"
#import "UpgradeViewController.h"

@interface MainWindowController : NSWindowController <NSOutlineViewDelegate, NSOutlineViewDataSource> {
    
    IBOutlet NSProgressIndicator *activityIndicator;
    int _taskCount;
    BOOL _storeIsReady;
    
    IBOutlet NSView *_mainContentView;
    NSViewController *_currentContentViewController;
    
    IBOutlet NSView *leftview;
    
    IBOutlet NSOutlineView *_sidebarOutlineView;
    NSArray *_topLevelItems;
    NSMutableDictionary *_childrenDictionary;
    
    CompanyViewController *_companyViewController;
    PeopleViewController *_peopleViewController;
    UpgradeViewController *_upgradeViewController;

}

- (IBAction)setUpgradeView:(id)sender;

@end
