//
//     File: SidebarTableCellView.m
//
//
#import "OSSidebarTableCellView.h"



@implementation OSSidebarTableCellView

@synthesize button = _button;

- (void)awakeFromNib {
    // We want it to appear "inline"
    [[self.button cell] setBezelStyle:NSInlineBezelStyle];
    [[self.addButton cell] setBezelStyle:NSInlineBezelStyle];
    [[self.removeButton cell] setBezelStyle:NSInlineBezelStyle];
    self.canDelete = NO;
    self.isCategory = NO;
    [self.addButton setHidden:YES];
    [self.removeButton setHidden:YES];
    [self.addButton setBordered:NO];
    [self.removeButton setBordered:NO];
}

- (void)dealloc {
    self.button = nil;
    self.addButton = nil;
    self.removeButton = nil;
}

// The standard rowSizeStyle does some specific layout for us. To customize layout for our button, we first call super and then modify things
- (void)viewWillDraw {
    [super viewWillDraw];
    if (![self.button isHidden]) {
        [self.button sizeToFit];
        
        NSRect textFrame = self.textField.frame;
        NSRect buttonFrame = self.button.frame;
        buttonFrame.origin.x = NSWidth(self.frame) - NSWidth(buttonFrame);
        self.button.frame = buttonFrame;
        textFrame.size.width = NSMinX(buttonFrame) - NSMinX(textFrame);
        self.textField.frame = textFrame;
    }
    if (![self.addButton isHidden]) {
        //[self.button sizeToFit];
        
        NSRect textFrame = self.textField.frame;
        NSRect buttonFrame = self.addButton.frame;
        buttonFrame.origin.x = NSWidth(self.frame) - 2 * NSWidth(buttonFrame) - 1;
        self.addButton.frame = buttonFrame;
        textFrame.size.width = NSMinX(buttonFrame) - NSMinX(textFrame);
        self.textField.frame = textFrame;
    }
    if (![self.removeButton isHidden]) {
        //[self.button sizeToFit];
        
        //NSRect textFrame = self.textField.frame;
        NSRect buttonFrame = self.removeButton.frame;
        buttonFrame.origin.x = NSWidth(self.frame) - NSWidth(buttonFrame);
        self.removeButton.frame = buttonFrame;
    }
}
/*
- (void)ensureTrackingArea {
    if (trackingArea == nil) {
        trackingArea = [[NSTrackingArea alloc] initWithRect:NSZeroRect options:NSTrackingInVisibleRect | NSTrackingActiveAlways | NSTrackingMouseEnteredAndExited owner:self userInfo:nil];
    }
}

- (void)updateTrackingAreas {
    [super updateTrackingAreas];

    [self ensureTrackingArea];
    if (![[self trackingAreas] containsObject:trackingArea]) {
        [self addTrackingArea:trackingArea];
    }
}
- (void)mouseEntered:(NSEvent *)theEvent
{
    //LOG(@"mouseEntered called");
    //FLOG(@" category is %@", self.objectValue);
    if (self.isCategory) {
        if ([self.button isHidden]) {
            [self.addButton setHidden:NO];
            if (self.canDelete)
                [self.removeButton setHidden:NO];
        }
    }
}
- (void)mouseExited:(NSEvent *)theEvent {
    //LOG(@"mouseExited called");
    [self.addButton setHidden:YES];
    [self.removeButton setHidden:YES];
}
 */
- (void)setFound:(BOOL)found
{
    
    if (found) {
        [self.textField setTextColor:[NSColor greenColor]];
        [[self.button cell] setHighlightsBy:0];
        [self.button setHidden:NO];
        [self.addButton setHidden:YES];
        [self.removeButton setHidden:YES];
    } else {
        [self.textField setTextColor:[NSColor blackColor]];
        [self.button setHidden:YES];        
    }
}

- (void)controlTextDidEndEditing:(NSNotification *)aNotification
{
    FLOG(@" called here");
    FLOG(@" category is %@", self.objectValue);
    FLOG(@" new text is %@", [[aNotification object] stringValue]);
    [self.objectValue setValue:[[aNotification object] stringValue] forKey:@"name"];
}
@end
